"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var BS5FloatingAutocompleteList = /** @class */ (function (_super) {
    __extends(BS5FloatingAutocompleteList, _super);
    function BS5FloatingAutocompleteList(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            value: props.defaultValue || '',
            list: []
        };
        _this.valueOnChange = _this.valueOnChange.bind(_this);
        _this.selectedValue = _this.selectedValue.bind(_this);
        _this.inputClick = _this.inputClick.bind(_this);
        _this.onKeyPress = _this.onKeyPress.bind(_this);
        return _this;
    }
    BS5FloatingAutocompleteList.prototype.componentDidMount = function () {
        var _this = this;
        this.loadList(this.state.value);
        // Call dropdown via JavaScript
        Promise.resolve().then(function () { return require("bootstrap"); }).then(function (bs) {
            var dropdownElm = document.getElementById(_this.props.id + 'Input');
            if (dropdownElm) {
                _this.dropdown = new bs.Dropdown(dropdownElm);
            }
        });
    };
    BS5FloatingAutocompleteList.prototype.loadList = function (value) {
        var list = [];
        if (value.length >= this.props.startAt) {
            // Find values
            list = this.props.list.filter(function (item) {
                return item.toLowerCase().includes(value.toLowerCase());
            });
            // Insert bold tag
            if (value.length > 0) {
                list = list.map(function (item) {
                    var valueIndex = item.toLowerCase().indexOf(value.toLowerCase());
                    var newItem = item.substring(0, valueIndex) + '<b>' + item.substring(valueIndex, valueIndex + value.length) + '</b>' + item.substring(valueIndex + value.length);
                    return newItem;
                });
            }
            this.setState({ list: list });
        }
        else {
            this.setState({ list: list });
        }
    };
    BS5FloatingAutocompleteList.prototype.valueOnChange = function (event) {
        var value = event.target.value;
        this.setState({ value: value });
        this.loadList(value);
        // Send on change value
        if ('valueOnChange' in this.props) {
            this.props.valueOnChange(value);
        }
    };
    BS5FloatingAutocompleteList.prototype.selectedValue = function (index, event) {
        event === null || event === void 0 ? void 0 : event.preventDefault();
        // Remove bold tag
        var value = this.state.list[index].replace(/<b>|<\/b>/gi, '');
        this.setState({ value: value });
        this.loadList(value);
        // Send selected value
        if ('selectedValue' in this.props) {
            this.props.selectedValue(value);
        }
    };
    BS5FloatingAutocompleteList.prototype.inputClick = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                (_a = this.dropdown) === null || _a === void 0 ? void 0 : _a.show();
                return [2 /*return*/];
            });
        });
    };
    BS5FloatingAutocompleteList.prototype.onKeyPress = function (event) {
        var _a;
        if (event.key === 'Enter' && this.state.list.length === 1) {
            this.selectedValue(0);
            (_a = this.dropdown) === null || _a === void 0 ? void 0 : _a.hide();
        }
    };
    BS5FloatingAutocompleteList.prototype.render = function () {
        var _this = this;
        return ((0, jsx_runtime_1.jsxs)("div", __assign({ className: "form-floating", id: this.props.id }, { children: [(0, jsx_runtime_1.jsx)("input", { type: "text", value: this.state.value, onKeyPress: this.onKeyPress, onChange: this.valueOnChange, className: "form-control", onClick: this.inputClick, id: this.props.id + 'Input', placeholder: this.props.label, "data-bs-toggle": "dropdown", autoComplete: "off", "data-bs-display": "static" }), (0, jsx_runtime_1.jsx)("label", __assign({ htmlFor: this.props.id + 'input' }, { children: this.props.label })), (0, jsx_runtime_1.jsx)("ul", __assign({ id: this.props.id + 'Dropdown', className: "dropdown-menu w-100", style: { maxHeight: this.props.maxHeight, overflowY: 'auto' }, hidden: this.state.list.length === 0 ? true : false }, { children: this.state.list.map(function (item, index) {
                        return (0, jsx_runtime_1.jsx)("li", { children: (0, jsx_runtime_1.jsx)("a", { className: "dropdown-item", href: "#0", onClick: function (event) { return _this.selectedValue(index, event); }, dangerouslySetInnerHTML: { __html: item } }) }, index);
                    }) }))] })));
    };
    BS5FloatingAutocompleteList.defaultProps = {
        id: 'autocompleteList',
        label: 'Autocomplete List',
        startAt: 0,
        maxHeight: '200px',
        list: ['Item 1', 'Item 2', 'Item 3'],
        selectedValue: function (valie) { },
        valueOnChange: function (valie) { }
    };
    return BS5FloatingAutocompleteList;
}(react_1.Component));
exports["default"] = BS5FloatingAutocompleteList;
